Software/KPICore/ViewModels/Builder/BuilderKpiViewModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AEWeb.ViewModels.Builder
{
    public class BuilderKpiViewModel : BuilderComponentViewModel
    {
        public BuilderKpiViewModel() : base(null)
        {

        }
    }
}

Software/KPICore/Controllers/Dashboard/DashboardKpiController.cs
using AEWeb.Controllers.Shared;
using AEWeb.Utilities;
using AEWeb.ViewModels.KPI;
using Domain.Dashboard;
using Domain.Indicators;
using Domain.Security;
using Framework.Kpi;
using Framework.Utilities;
using Infrastructure.Mediator.Dashboard.Queries;
using Infrastructure.Mediator.Indicator.Commands;
using Infrastructure.Mediator.Indicator.Queries;
using Infrastructure.ViewModels.KPI;
using KPIClassLibrary.KPI;
using MediatR;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Localization;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AEWeb.Controllers.Dashboard
{
    public class DashboardKpiController : I18nController
    {
        private ILogger<DashboardKpiController> _logger;
        private IStringLocalizer<SharedResources> _localizer;
        private IMediator _mediator;
        private UserManager<ApplicationUser> _userManager;
        private Framework.Service.IUnitOfWork _unitOfWork;
        private IKpiDataGetter _kpiDataGetter;
        private IWebHostEnvironment _hostingEnvironment;
        private IChartUtilities _chartUtilities;

        public DashboardKpiController(ILogger<DashboardKpiController> logger,
            IStringLocalizer<SharedResources> localizer,
            IMediator mediator,
            Framework.Service.IUnitOfWork unitOfWork,
            IKpiDataGetter kpiDataGetter,
            IWebHostEnvironment hostingEnvironment,
            UserManager<ApplicationUser> userManager,
            IChartUtilities chartUtilities)
        {
            _logger = logger;
            _localizer = localizer;
            _mediator = mediator;
            _userManager = userManager;
            _unitOfWork = unitOfWork;
            _kpiDataGetter = kpiDataGetter;
            _hostingEnvironment = hostingEnvironment;
            _chartUtilities = chartUtilities;
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> Index(string rowid)
        {
            string metadataPath = Utilities.ConfigUtilities.GetMetaDataPath(_hostingEnvironment);
            string jsonGroupPath = Utilities.ConfigUtilities.GetGroupsDataPath(_hostingEnvironment);
            KPIClassLibrary.KPI.KPICatalog catalog = new KPIClassLibrary.KPI.KPICatalog(jsonGroupPath, metadataPath);

            DashboardRow row = await _mediator.Send(new GetDashboardRowQuery() { RowId = Guid.Parse(rowid) });
            DashboardConfiguration dashboardConfig = await _mediator.Send(new GetDashboardConfigurationQuery() { 
                DashboardConfigurationGuid = row.ConfigurationRef.DashboardConfigurationId.ToString()
            });            

            List<Domain.Indicators.Kpi> kpis = 
                await _mediator.Send(new GetListKpisQuery() { DashboardRowId = rowid });

            KpiListViewModel model = KpiListViewModel.FromListKpi(kpis, catalog);
            model.RowId = Guid.Parse(rowid);
            model.DashboardId = dashboardConfig.DashboardRef.DashboardId;
            return View(model);
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> MoveKpiUp(string rowid, string kpiid)
        {
            DashboardRow dashboardRow = 
                await _mediator.Send(new GetDashboardRowQuery() { RowId = Guid.Parse(rowid) });
            List<Domain.Indicators.Kpi> kpis =
                 await _mediator.Send(new GetListKpisQuery() { DashboardRowId = rowid });

            Domain.Indicators.Kpi upKpi = kpis.Single(x => x.KpiId == new Guid(kpiid));
            Domain.Indicators.Kpi tempKpi = kpis.Single(x => x.CellNumber == upKpi.CellNumber - 1);
            tempKpi.CellNumber++;
            upKpi.CellNumber--;
            await _mediator.Send(new UpdateKpiCommand(tempKpi));
            await _mediator.Send(new UpdateKpiCommand(upKpi));
            await _unitOfWork.Commit();

            return RedirectToAction("EasyEdit", "Dashboard", 
                new { id = dashboardRow.ConfigurationRef.DashboardRef.DashboardId });
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> MoveKpiDown(string rowid, string kpiid)
        {
            DashboardRow dashboardRow =
                await _mediator.Send(new GetDashboardRowQuery() { RowId = Guid.Parse(rowid) });

            List<Domain.Indicators.Kpi> kpis =
                  await _mediator.Send(new GetListKpisQuery() { DashboardRowId = rowid });

            Domain.Indicators.Kpi upKpi = kpis.Single(x => x.KpiId == new Guid(kpiid));
            Domain.Indicators.Kpi tempKpi = kpis.Single(x => x.CellNumber == upKpi.CellNumber + 1);
            tempKpi.CellNumber--;
            upKpi.CellNumber++;
            await _mediator.Send(new UpdateKpiCommand(tempKpi));
            await _mediator.Send(new UpdateKpiCommand(upKpi));
            await _unitOfWork.Commit();

            return RedirectToAction("EasyEdit", "Dashboard",
                new { id = dashboardRow.ConfigurationRef.DashboardRef.DashboardId });
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> Create(Guid rowid)
        {
            Domain.Dashboard.DashboardRow row = await _mediator.Send(new GetDashboardRowQuery() { RowId = rowid });
            KpiViewModel kpi = new KpiViewModel();
            kpi.DashboardRowId = row.DashboardRowId;
            return View("Edit", kpi);
        }

        [HttpPost]
        [Authorize]
        public async Task<IActionResult> Insert(KpiViewModel model)
        {
            Kpi kpiToInsert = new Kpi();
            Guid rowId = model.DashboardRowId;
            kpiToInsert.DivHeight = 1;
            kpiToInsert.DivWidth = 4;
            kpiToInsert.FilterValue = "";
            kpiToInsert.Title = model.KpiMnemonic;
            kpiToInsert.NumberOfYears = 5;
            kpiToInsert.PeriodYear = DateTime.Now.Year;

            KPI baseKpi = _chartUtilities.GetKPIFromCatalog(model.KpiMnemonic, "");
            kpiToInsert.ViewType = ChartUtilities.GetKpiViewModelFrom(baseKpi.GetSupportedChartTypes().First());

            Domain.Dashboard.DashboardRow dashboardRow = await _mediator.Send(new GetDashboardRowQuery()
            {
                RowId = rowId
            });

            List<Kpi> kpis = await _mediator.Send(new GetListKpisQuery() { DashboardRowId = rowId.ToString() });
            int maxCellNumber = 0;
            if (kpis.Count > 0)
                maxCellNumber = kpis.Aggregate((curMax, x) => (curMax == null || (x.CellNumber ?? 0) >
                    curMax.CellNumber ? x : curMax)).CellNumber;

            kpiToInsert.CellNumber = maxCellNumber + 1;

            Domain.Dashboard.DashboardConfiguration dashboardConfiguration =
                await _mediator.Send(new GetDashboardConfigurationQuery()
                {
                    DashboardConfigurationGuid = dashboardRow.ConfigurationRef.DashboardConfigurationId.ToString()
                });
            

            Kpi insertedKpi = await _mediator.Send(new CreateKpiCommand()
            {
                NewKpi = kpiToInsert,
                DashboardRef = dashboardConfiguration.DashboardRef,
                RowRef = dashboardRow
            });

            _logger.LogInformation("The KPI " + model.KpiMnemonic + " has been inserted to row " + model.DashboardRowId);

            return RedirectToAction("Edit", new { id = insertedKpi.KpiId.ToString() });
        }

        [HttpPost]
        [Authorize]
        public async Task<IActionResult> Update(KpiViewModel model)
        {
            string metadataPath = Utilities.ConfigUtilities.GetMetaDataPath(_hostingEnvironment);
            string jsonGroupPath = Utilities.ConfigUtilities.GetGroupsDataPath(_hostingEnvironment);

            Kpi kpiInCell = await _mediator.Send(new GetKpiQuery() 
            { 
                KpiId = model.DashboardKpiId.ToString(), 
                NoTracking = false 
            });

            KPIClassLibrary.KPI.KPI kpiInstance = _chartUtilities.GetKPIFromCatalog(model.KpiMnemonic, "");

            kpiInstance.GetKPIMetadata(jsonGroupPath, metadataPath);

            model.GroupId = kpiInstance.Name;
            model.SupportedChartTypes = kpiInstance.GetSupportedChartTypes();
            model.KpiMnemonic = kpiInCell.Title;

            // Updating 
            kpiInCell.DivWidth = model.DivWidth;
            kpiInCell.ViewType = ChartUtilities.GetKpiViewModelFrom(model.ChartType);
            await _mediator.Send(new UpdateKpiCommand(kpiInCell));
            _logger.LogInformation("the KPI " + kpiInCell.KpiId.ToString() + " has been updated");

            return RedirectToAction("Edit", new { id = kpiInCell.KpiId.ToString() });
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> Delete(string id)
        {
            Kpi kpiInCell = await _mediator.Send(new GetKpiQuery() { KpiId = id, NoTracking = true });

            Guid dashboardRowId = kpiInCell.RowRef.DashboardRowId;

            await _mediator.Send(new DeleteKpiCommand() { KpiId = Guid.Parse(id), RowId = dashboardRowId });

            return RedirectToAction("Index", new { rowid = dashboardRowId.ToString() });
        }

        [HttpGet]
        [Authorize]
        public async Task<IActionResult> Edit(string id)
        {
            string metadataPath = Utilities.ConfigUtilities.GetMetaDataPath(_hostingEnvironment);
            string jsonGroupPath = Utilities.ConfigUtilities.GetGroupsDataPath(_hostingEnvironment);

            Kpi kpiInCell = await _mediator.Send(new GetKpiQuery() { KpiId = id, NoTracking = true });

            KpiViewModel model = KpiViewModel.FromKpi(kpiInCell);
            KPIClassLibrary.KPI.KPI kpiInstance = _chartUtilities.GetKPIFromCatalog(model.KpiId, "");

Software/KPICore/Controllers/Dashboard/DashboardRowController.cs
using AEWeb.Controllers.Shared;
using AEWeb.ViewModels.Dashboard;
using Domain.Dashboard;
using Domain.Security;
using Framework.Dashboard;
using Framework.Kpi;
using Infrastructure.Mediator.Dashboard.Commands;
using Infrastructure.Mediator.Dashboard.Queries;
using MediatR;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Localization;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AEWeb.Controllers.Dashboard
{
    public class DashboardRowController : I18nController
    {
        private ILogger<DashboardRowController> _logger;
        private IStringLocalizer<SharedResources> _localizer;
        private IMediator _mediator;
        private UserManager<ApplicationUser> _userManager;
        private Framework.Service.IUnitOfWork _unitOfWork;
        private IKpiDataGetter _kpiDataGetter;
        private IWebHostEnvironment _hostingEnvironment;
        private IDashboardService _dashboardService;

        public DashboardRowController(ILogger<DashboardRowController> logger,
            IStringLocalizer<SharedResources> localizer,
            IMediator mediator,
            Framework.Service.IUnitOfWork unitOfWork,
            IKpiDataGetter kpiDataGetter,
            IWebHostEnvironment hostingEnvironment,
            UserManager<ApplicationUser> userManager,
            IDashboardService dashboardService)
        {
            _logger = logger;
            _localizer = localizer;
            _mediator = mediator;
            _userManager = userManager;
            _unitOfWork = unitOfWork;
            _kpiDataGetter = kpiDataGetter;
            _hostingEnvironment = hostingEnvironment;
            _dashboardService = dashboardService;
        }

        [HttpGet]
        public async Task<IActionResult> Index(string id)
        {
            Domain.Dashboard.Dashboard dashboard =
                await _mediator.Send(new GetDashboardQuery() { DashboardGuid = id });
            DashboardConfiguration dashboardConfiguration =
                await _mediator.Send(new GetDashboardConfigurationByDashboardQuery() { DashboardGuid = id });

            List<DashboardRow> dashboardRows =
                await _mediator.Send(new GetListDashboardRowsQuery()
                {
                    DashboardConfigurationGuid = dashboardConfiguration.DashboardConfigurationId
                });

            DashboardRowListViewModel model = DashboardRowListViewModel.FromListDashboardRow(dashboardRows);
            DashboardConfigurationViewModel configModel = 
                DashboardConfigurationViewModel.FromDashboardConfiguration(dashboardConfiguration);
            model.Parent = DashboardViewModel.FromDashboard(dashboard);
            model.Configuration = configModel;
            return View(model);
        }

        [HttpGet]
        public async Task<IActionResult> MoveRowUp(string id, Guid dashboardRowId)
        {
            await _dashboardService.RowMoveUp(id, dashboardRowId);

            return RedirectToAction(nameof(Index), new { id = id });
        }

        [HttpGet]
        public async Task<IActionResult> EasyMoveRowUp(string id, Guid id2)
        {
            Guid rowid = id2;
            try
            {
                DashboardConfiguration dashboardConfiguration =
                await _mediator.Send(new GetDashboardConfigurationByDashboardQuery()
                {
                    DashboardGuid = id
                });

                List<DashboardRow> dashboardRows =
                    await _mediator.Send(new GetListDashboardRowsQuery()
                    {
                        DashboardConfigurationGuid = dashboardConfiguration.DashboardConfigurationId
                    });

                DashboardRow upRow = dashboardRows.Single(x => x.DashboardRowId == rowid);
                DashboardRow tempRow = dashboardRows.Single(x => x.RowNumber == upRow.RowNumber - 1);
                tempRow.RowNumber++;
                upRow.RowNumber--;
                await _mediator.Send(new UpdateDashboardRowCommand(tempRow));
                await _mediator.Send(new UpdateDashboardRowCommand(upRow));
                //await _unitOfWork.Commit();

                _logger.LogInformation("Just moved the row " + rowid + " up one position");
            }
            catch (Exception q)
            {

                throw q;
            }
            return RedirectToAction("EasyEdit", "Dashboard", new { id = id });
        }

        [HttpGet]
        public async Task<IActionResult> MoveRowDown(string id, Guid dashboardRowId)
        {
            await _dashboardService.RowMoveDown(id, dashboardRowId);

            return RedirectToAction(nameof(Index), new { id = id });
        }

        [HttpGet]
        public async Task<IActionResult> EasyMoveRowDown(string id, Guid id2)
        {
            DashboardConfiguration dashboardConfiguration =
                await _mediator.Send(new GetDashboardConfigurationByDashboardQuery() { DashboardGuid = id });

            List<DashboardRow> dashboardRows =
                await _mediator.Send(new GetListDashboardRowsQuery()
                {
                    DashboardConfigurationGuid = dashboardConfiguration.DashboardConfigurationId
                });
            DashboardRow DownRow = dashboardRows.Single(x => x.DashboardRowId == id2);
            DashboardRow tempRow = dashboardRows.Single(x => x.RowNumber == DownRow.RowNumber + 1);
            tempRow.RowNumber--;
            DownRow.RowNumber++;
            await _mediator.Send(new UpdateDashboardRowCommand(tempRow));
            await _mediator.Send(new UpdateDashboardRowCommand(DownRow));
            //await _unitOfWork.Commit();

            _logger.LogInformation("Just moved the row " + id2 + " down one position");

            return RedirectToAction("EasyEdit", "Dashboard", new { id = id });
        }

        public async Task<IActionResult> CreateRow(DashboardRowListViewModel model)
        {
            List<DashboardRow> allRows = await _mediator.Send(new GetListDashboardRowsQuery()
            {
                DashboardConfigurationGuid = model.Configuration.DashboardConfigurationId
            });
            int newLastNumber = allRows.Count + 1;

            DashboardRow row = await _mediator.Send(new CreateDashboardRowCommand()
            {
                DashboardConfigurationId = model.Configuration.DashboardConfigurationId,
                RowNumber = newLastNumber
            });
            _logger.LogInformation("A new row has been added to configuration " + 
                model.Configuration.DashboardConfigurationId.ToString());

            return RedirectToAction(nameof(Index), 
                new { id = model.Parent.DashboardId.ToString() });
        }

        [HttpGet]
        [Authorize(Policy = "KPI_DASH_EDIT")]
        public async Task<IActionResult> DeleteRow(string id, string id2)
        {
            await _mediator.Send(new DeleteDashboardRowCommand() { RowId = id2 });

            return RedirectToAction("EasyEdit", "Dashboard", new { id = id });
        }
    }
}

Software/KPICore/Views/Dashboard/Builder.cshtml
@model AEWeb.ViewModels.Builder.BuilderDashboardViewModel
@using Microsoft.AspNetCore.Mvc.Localization
@addTagHelper *, AEWeb
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    ViewBag.Title = "Dashboard";
    Layout = "_DashboardLayout";
}

<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>Dashboard Builder</h2>
        <small>In the following page you can select the KPIs that will be part of your dashboard</small>
    </div>
    <div class="col-lg-2">

    </div>
</div>
<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-md-12">
        <form role="form" action="@Url.Action("AddElement","Dashboard")" method="post">
            <div class="row">
                <div class="col-md-8">
                </div>
                <div class="col-md-2">
                    <button type="submit" class="btn btn-default btn-sm">Add KPI</button>
                </div>                
            </div>
        </form>
    </div>
</div>
<div class="wrapper wrapper-content">
    <div class="row">
        <div class="col-lg-3">
            <vc:kpi-value-target kpi-key="KpiTaxGdpRatio" id="1"></vc:kpi-value-target>
        </div>
    </div>
</div>

Software/KPICore/Views/Dashboard/Create.cshtml
@model AEWeb.ViewModels.Dashboard.DashboardViewModel
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    ViewBag.Title = "Create a dashboard";
}

<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>@Localizer["PageTitle"]</h2>
        <small>@Localizer["PageDescription"]</small>
    </div>
    <div class="col-lg-2">

    </div>
</div>

<div class="wrapper wrapper-content">

    <div class="row">
        <div class="col-lg-12">
            <div class="ibox">
                <div class="ibox-title">
                    
                    <a asp-action="Index">@Localizer["BackToList"]</a>
                </div>
                <div class="ibox-content">
                    <div class="container-fluid">
                        <div class="row">
                            <form asp-action="Save" method="post" class="col-md-5">
                                <input type="hidden" asp-for="DashboardId" />
                                @*<div asp-validation-summary="ModelOnly" class="text-danger"></div>*@
                                <div class="form-group">
                                    <label asp-for="Name" class="control-label"></label>
                                    <input asp-for="Name" class="form-control" />
                                    <span asp-validation-for="Name" class="text-danger" ></span>
                                </div>
                                <div class="form-group">
                                    <label asp-for="Type" class="control-label"></label>
                                    <select asp-for="Type" class="form-control">
                                        <option value="">@Localizer["SelectAType"]</option>
                                        <option value="Strategic">@Localizer["StrategicType"]</option>
                                        <option value="Operational">@Localizer["OperationalType"]</option>
                                        <option value="Tactical">@Localizer["TacticalType"]</option>
                                    </select>
                                    <span asp-validation-for="Type" class="text-danger"></span>
                                </div>
                                <div class="form-group">
                                    <label asp-for="Status" class="control-label"></label>
                                    <select asp-for="Status" class="form-control">
                                        <option value="">@Localizer["SelectAStatus"]</option>
                                        <option value="DRAFT">@Localizer["DraftStatus"]</option>
                                        <option value="PUBLISHED">@Localizer["PublishedStatus"]</option>
                                        <option value="HIDDEN">@Localizer["HiddenStatus"]</option>
                                    </select>
                                    <span asp-validation-for="Status" class="text-danger"></span>
                                </div>
                                <div class="form-group">
                                    <input type="submit" value="Create" class="btn btn-primary" />
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@section Scripts {

    <script src="~/lib/jquery-validation/dist/jquery.validate.js"></script>
    <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.js"></script>
}

Software/KPICore/Views/Dashboard/EditDashboard.cshtml
@model AEWeb.ViewModels.Dashboard.DashboardViewModel
@using AEWeb.ViewModels.KPI
@using AEWeb.ViewModels.Dashboard
@using Domain.Enums.Indicators
@using Microsoft.AspNetCore.Mvc.Localization
@addTagHelper *, AEWeb
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    ViewBag.Title = Model.Name;
    Layout = "_DashboardLayout";
}
@section Styles {
    <style>
        .dashboardrow {
            border: 2px dashed #666;
        }
        /* HIDE RADIO */
        .imageSelector [type=radio] {
            position: absolute;
            opacity: 0;
            width: 0;
            height: 0;
        }

            /* IMAGE STYLES */
            .imageSelector [type=radio] + img {
                cursor: pointer;
            }

            /* CHECKED STYLES */
            .imageSelector [type=radio]:checked + img {
                outline: 2px solid #01cdd4;
            }
    </style>
}

<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>@Localizer["PageTitle"]</h2>
        <small>            
            @Localizer["PageDescription"]
        </small>
    </div>
    <div class="col-lg-2">

    </div>
</div>

<div class="modal inmodal" id="deleteModalConfirm" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content animated flipInY">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">@Localizer["Close"]</span></button>
                <h4 class="modal-title">@Localizer["TitleConfirmDelete"]</h4>
            </div>
            <div class="modal-body">
                <p>
                    @Html.Raw(Localizer["ConfirmDelete"])
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-white" data-dismiss="modal">@Localizer["No"]</button>
                <a href="/Home" class="btn btn-primary actionYesModal">@Localizer["Yes"]</a>
            </div>
        </div>
    </div>
</div>

@{
    var lastRowDimension = "";
}
<div class="wrapper wrapper-content">
    <div class="row">
        <div class="col-lg-12">
            <div class="ibox-title">
                <div class="col-md-10">&nbsp;</div>
                <div class="col-md-2">
                    <a asp-action="Index" asp-controller="Dashboard">Back to dashboards</a>
                </div>
            </div>
            <div class="ibox-content">
                <div class="container-fluid">
                    @foreach (DashboardRowViewModel row in Model.Config.Rows)
                    {
                        if (!row.Dimension.Equals(lastRowDimension))
                        {
                            var dimensionidrow = "dimensionid" + row.RowNumber;

                            lastRowDimension = row.Dimension;
                        }
                        <div class="dashboardrow">
                            <div class="">
                                <a asp-action="EasyEditRow" asp-controller="Dashboard" asp-route-rowid="@row.DashboardRowID">
                                    <i class="fa fa-list-ol"></i>
                                </a>
                                <a class="deleterow" href="#"
                                   data-toggle="modal" data-target="#deleteModalConfirm" data-rowid="@row.DashboardRowID">
                                    <i class="fa fa-trash"></i>
                                </a>
                                @if (row.RowNumber > 1)
                                {
                                    <a asp-controller="DashboardRow" asp-action="EasyMoveRowUp" asp-route-id="@Model.DashboardId" asp-route-id2="@row.DashboardRowID">
                                        <i class="fa fa-arrow-up"></i>
                                    </a>
                                }
                                @if (row.RowNumber < Model.Config.Rows.Count)
                                {
                                    <a asp-controller="DashboardRow" asp-action="EasyMoveRowDown" asp-route-id="@Model.DashboardId" asp-route-id2="@row.DashboardRowID">
                                        <i class="fa fa-arrow-down"></i>
                                    </a>
                                }
                            </div>
                            <div class="row">
                                @{
                                    var closeDiv = "";
                                }
                                @foreach (KpiViewModel kpi in row.Kpis)
                                {
                                    @if (!kpi.SameColumnThanPrevious)
                                    {
                                        @Html.Raw(closeDiv)
                                        @Html.Raw(kpi.DivColumnStart)
                                    }

                                    @if (kpi.Type != KpiViewModelType.None)
                                    {
                                        <vc:kpi-generic kpi-key="@kpi.KpiMnemonic" id="@kpi.KpiId"></vc:kpi-generic>
                                    }
                                    else
                                    {
                                        <vc:kpi-not-supported kpi-key="@kpi.KpiMnemonic" id="@kpi.KpiId"></vc:kpi-not-supported>
                                    }
                                    closeDiv = "</div>";
                                }
                                @Html.Raw(closeDiv)
                            </div>
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>

    
</div>

@section Scripts {
    <script src="~/lib/kpi/sparkline.js"></script>
    <script src="~/lib/kpi/columnchart.js"></script>
    <script src="~/lib/kpi/piechart.js"></script>

    <script>
        Highcharts.setOptions({
            //colors: ['#2C82C9', '#61BD6D', '#ED561B', '#F7DA64', '##FBA026', '#EB6B56', '#A38F84', '#9365B8', '#3D8EB9','#41A85F','#FAC51C','#F37934','#D1D5D8','#475577']
            colors: ['#16A64F', '#B8E259', '#0B8695', '#60C7B9', '#E9832A', '#FEBB40', '#B73A8D']
        });

        $(document).ready(function () {

            // Add slimscroll to element
            $('.scroll_content').slimscroll({
                height: '400px'
            });

            $('#deleteModalConfirm').on('show.bs.modal', function (event) {
                var button = $(event.relatedTarget); // Button that triggered the modal
                var rowid = button.data('rowid'); // Extract info from data-* attributes
                var dashboardid = '@Model.DashboardId';
                var modal = $(this);
                modal.find('.actionYesModal')[0].href = '/DashboardRow/DeleteRow/' + dashboardid + '/' + rowid;
            });
        });

    </script>
}